# WSCF

WSCF (WebSocket Communication Foundation) 就是 抄 微软的WCF， 但有 推送功能。  

# 1. 项目描述
**WSCF** 基于 .net framework 4.6.1 <br>
**WSCF.standard** 可以在 .net core 跑的 <br>
**WSCF.Test** 项目测试 库<br>
**WSCF.Test.Client** 测试客户端<br>
**WSCF.Test.Server** 测试服务器<br>

<br>
<br>
<br>
<br>


# 2. 使用方法
1. 定义服务接口 IXXXService

//WSCF.Test/IService/IFooService.cs

2. 在服务器中，创建 类 XXX 实现 IXXXService 接口

//WSCF.Test/Server/Foo.cs

3. 在服务器中，

//WSCF.Test/Server.WsProxy/WsProxy.cs
```csharp
wssv = new WebSocketServer($"ws://{addr}/");
wssv.AddWebSocketService<Reflect_Proxy>("/Foo", (wsproxy) =>
{
    //IFooService 服务接口, foo 继承IFooService的类Foo 的对象
    wsproxy.Init(typeof(IFooService), foo); 
});

//如果有多个服务，就继续 wssv.AddWebSocketService<Reflect_Proxy>
this.wssv.Start();
```

4. 在客户端中

创建 类 XXXServiceClient 实现 IXXXService 接口

//WSCF.Test/ServiceClient/FooServiceClient.cs

最后使用
```csharp

//后面的 "foo" 是连接的名字，对应 地址 { Addr = "127.0.0.1:5540", ConnName = "foo" } 
// WSCF.FObjServiceClientManager 负责维护这个地址列表
Foo = new WSCF.Test.ServiceClient.FooServiceClient("Foo", true, "foo");
```


<br>
<br>
<br>
<br>


# 3. 描述

服务代理 它还另一个版本 在项目 FObjBase.Reflect

1. 如果代理的对象为 INotifyPropertyChanged, 对象内的 property 改变，能推送给客户端( [JsonIgnore] 除外);
2. 代理的对象不为INotifyPropertyChanged, 但 对象内的 property 

    + 是 [PropertyPush], 
    + 且是 INotifyPropertyChanged, 
    + 且 只能是get,不能有set

 那这个 property 内的 子property 改变，也会推送给 客户端 且 子property 是 [PropertyPush]，会继续向下全部注册 PropertyChanged, 也推送给 客户端;

3. 客户端 可以通过 Call(.....) 调用 服务 的function,  function返回的内容，需要通过[Call(...)] 定义; 且function 必须是 
```csharp
    void function(object param1, object param2,object paramN, AsyncCBHandler asyncDelegate, object asyncContext);
    //必须有参数 AsyncCBHandler asyncDelegate, object asyncContext， 名字不能改。 前面的 param1~paramN， 多少个都行
```
4. 服务中的event, 通过 [Push(...)] 可以推送给客户端， 但event 只能是 EventHandler
```csharp
     [Push(typeof(BulkDBTempFrameChangedEventArgs))]
     public event EventHandler TempFrameChanged;
```
