﻿using GalaSoft.MvvmLight.Command;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WSCF.Test.IService;

namespace WSCF.Test.Client
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        MainVm mainVm;
        public MainWindow()
        {
            InitializeComponent();

            //创建连接 
            //正常情况 FObjServiceClientManager 从配置文件读取
            //最终的目标方便 UnityContainer 使用
            WSCF.FObjServiceClientManager.Instance.DefaultAddrs.Add(new ConnDefaultAddr() { Addr = "127.0.0.1:5540", ConnName = "foo" });

            mainVm = new MainVm();
            mainVm.Init();
            this.DataContext = mainVm;

        }


    }
    public class MainVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public WSCF.Test.IService.IFooService Foo { get; set; }

        public int A { get; set; }
        public int B { get; set; }
        public int Result { get; set; }

        public RelayCommand AddCmd { get; }

        public MainVm() 
        {
            AddCmd = new RelayCommand(Add);
        }
        public void Init() 
        {
            //后面的 "foo" 是连接的名字，对应 上面 { Addr = "127.0.0.1:5540", ConnName = "foo" }
            Foo = new WSCF.Test.ServiceClient.FooServiceClient("Foo", true, "foo");
        }
        void Add() 
        {
            Foo.Add(A, B, (asyncContext, retData) =>
            {
                FooServiceAddReponse reponse = retData as FooServiceAddReponse;
                Result = reponse.result;
            }, this);
        }
    }
}
