﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WSCF.Test.IService;

namespace WSCF.Test.ServiceClient
{
    //很机械式 按格式填就好，下一个版本，会有软件 自动生成下面的代码
    public class FooServiceClient : Reflect_SeviceClient, IFooService
    {
        //注明要实现的服务接口
        protected override Type InterfaceType => typeof(IFooService);

        //只要是property，get, set 都必须 public  就算 IFooService.Number 只有 Get没有Set
        public int Number { get; set; }

        public DateTime AddFuncTime { get; set; }

        public string Msg { get; set; }

        public int[] Abc { get; set; }

        public ProfileParam Param { get; } = new ProfileParam();
        public Bar[] Bars { get; set; } 
        public FooServiceClient(string serverName, bool isByConnName, string addrOrConnName):base(serverName, isByConnName, addrOrConnName)
        {

        }

        
        public event EventHandler DataChanged;
        /// <summary>
        /// 只要是事件，都只能手动 创建 Trigger_xxxx(xxxx为event名称)，作为触发事件的函数，该函数的参数类型就是Push 里面定义的
        /// </summary>
        /// <param name="e"></param>
        public void Trigger_DataChanged(DataChangedEventArgs e)
        {
            DataChanged?.Invoke(this, e);
        }


        public void Add(int a, int b, AsyncCBHandler asyncDelegate, object asyncContext)
        {
            //Call 的 parameters 必须写 为 new {a, b} 这样简写模式, 因为需要匹配 参数名字
            Call(nameof(Add), new { a, b }, asyncDelegate, asyncContext);
        }

        public void Apply(ProfileParam param)
        {
            //如果连参数也没有，只需要写 Call(nameof(Apply));
            Call(nameof(Apply), new { param });
        }
    }
}
